import "./style.css";

import { pollAndTouch } from "./screen.ts";
import { getClock } from "./clock.ts";
import { getInput, setupInput } from "./input.ts";
import { IGame } from "../datatypes.ts";

export function hostGame(game: IGame) {
  let gameCanvas = document.getElementById("game") as HTMLCanvasElement;
  setupInput(gameCanvas);
  onFrame(game, undefined); // start on-frame draw loop, set up screen
}

function onFrame(game: IGame, timestamp: number | undefined) {
  let gameCanvas = document.getElementById("game") as HTMLCanvasElement;
  requestAnimationFrame((timestamp: number) => onFrame(game, timestamp));

  if (timestamp) {
    getClock().recordTimestamp(timestamp);
  }
  onFrameFixScreen(gameCanvas);

  while (getClock().popUpdate()) {
    game.update();
    getInput().update();
  }

  game.draw();
}

function onFrameFixScreen(canvas: HTMLCanvasElement) {
  pollAndTouch(canvas);
}
